Package org.gitana.platform.client.node

# Class NodeImpl

java.lang.Object
org.gitana.platform.support.GitanaObjectImpl
org.gitana.platform.client.document.DocumentImpl
org.gitana.platform.client.platform.AbstractPlatformDocumentImpl
org.gitana.platform.client.repository.AbstractRepositoryDocumentImpl
org.gitana.platform.client.node.BaseNodeImpl
org.gitana.platform.client.node.NodeImpl

All Implemented Interfaces:
  `Serializable`, `Attachable`, `Document`, `BaseNode`, `Node`, `PlatformDocument`, `RepositoryDocument`, `AccessControllable`, `Copyable`, `Referenceable`, `Selfable`, `TitleDescription`, `Transferable`, `TypedID`, `org.gitana.platform.GitanaObject`, `org.gitana.platform.JSONable`

Direct Known Subclasses:
  `AbstractDefinitionImpl`, `FeatureDefinitionImpl`, `FormImpl`, `GroupImpl`, `NodeListImpl`, `PersonImpl`, `RuleImpl`

public class NodeImpl extends BaseNodeImpl implements Node
Default "n:node" implementation for a node. This class is the base class for all nodes in the Gitana repository.

Author:
  uzi
See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class org.gitana.platform.support.GitanaObjectImpl

`serialVersionUID`

### Fields inherited from interface org.gitana.platform.client.node.BaseNode

`FIELD_FEATURES, FIELD_QNAME, FIELD_TYPE_QNAME, SYSTEM_CHANGESET, SYSTEM_DELETED`

### Fields inherited from interface org.gitana.platform.client.document.Document

`FIELD_ID, SYSTEM, SYSTEM_CREATED_BY, SYSTEM_CREATED_ON, SYSTEM_MODIFIED_BY, SYSTEM_MODIFIED_ON`

### Fields inherited from interface org.gitana.platform.client.support.TitleDescription

`FIELD_DESCRIPTION, FIELD_TITLE`

## Constructor Summary

Constructors
Constructor
Description
`NodeImpl(Branch branch, com.fasterxml.jackson.databind.node.ObjectNode obj, boolean isSaved)`
Existing node constructor.

## Method Summary

Modifier and Type
Method
Description
`Association`
`associate(Node targetNode, org.gitana.platform.support.QName associationTypeQName)`
Associates a target node to this source node.
`Association`
`associate(Node targetNode, org.gitana.platform.support.QName associationTypeQName, com.fasterxml.jackson.databind.node.ObjectNode object)`
Associates a target node to this source node.
`Association`
`associate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality)`
Associates this node with another.
`Association`
`associate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality, com.fasterxml.jackson.databind.node.ObjectNode object)`
Associates this node with another.
`org.gitana.platform.support.ResultMap<Association>`
`associations()`
Lists all associations in ANY direction involving this node.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.services.association.Direction direction)`
Lists all association in the given direction involving this node.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)`
Lists all association in the given direction involving this node.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.support.Pagination pagination)`
Lists all associations in ANY direction involving this node.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.support.QName associationTypeQName)`
Lists all associations of the given type in ANY direction involving this node.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Direction direction)`
Lists all associations of the given type in the specified direction.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)`
Lists all associations of the given type in the specified direction.
`org.gitana.platform.support.ResultMap<Association>`
`associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.support.Pagination pagination)`
Lists all associations of the given type in ANY direction involving this node.
`Node`
`createTranslation(String edition, Locale locale, com.fasterxml.jackson.databind.node.ObjectNode object)`
Creates a new translation.
`com.fasterxml.jackson.databind.node.ObjectNode`
`fileFolderTree()`
`com.fasterxml.jackson.databind.node.ObjectNode`
`fileFolderTree(String basePath)`
`com.fasterxml.jackson.databind.node.ObjectNode`
`fileFolderTree(String basePath, int depth, List<String> leafPaths, boolean includeProperties, boolean containersOnly, com.fasterxml.jackson.databind.node.ObjectNode query)`
`com.fasterxml.jackson.databind.node.ObjectNode`
`fileFolderTree(String basePath, String leafPath)`
`com.fasterxml.jackson.databind.node.ObjectNode`
`fileFolderTree(TreeLookupOptions options)`
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse)`
Queries and searches for nodes in the defined traversal space around this node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse, LookupOptions options)`
Queries and searches for nodes in the defined traversal space around this node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse, org.gitana.platform.support.Pagination pagination)`
Queries and searches for nodes in the defined traversal space around this node.
`ACL`
`getACL()`
`List<String>`
`getACL(String principalId)`
Retrieve the authorities that a principal has.
`Map<String,Map<String,org.gitana.platform.services.authority.AuthorityGrant>>`
`getAuthorityGrants(List<String> principalIds)`
Acquires a map of authority grants for a set of principals.
`List<String>`
`getTranslationEditions()`
`List<Locale>`
`getTranslationLocales(String edition)`
Hands back the locales available for a given edition of translations for this master node.
`String`
`getTypeId()`
`void`
`grant(String principalId, String authorityId)`
Grants an authority to a principal.
`void`
`grant(DomainPrincipal principal, String authorityId)`
`boolean`
`hasAuthority(String principalId, String authorityId)`
Checks whether the principal has the given authority over this object.
`boolean`
`hasAuthority(DomainPrincipal principal, String authorityId)`
`boolean`
`hasPermission(String principalId, String permissionId)`
Checks whether the principal has the given permission over this object.
`boolean`
`hasPermission(DomainPrincipal principal, String permissionId)`
`org.gitana.platform.support.ResultMap<BaseNode>`
`listChildren()`
Retrieves the children of the current node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`listChildren(org.gitana.platform.support.Pagination pagination)`
Retrieves the children of the current node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`listRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction)`
Retrieves the relatives of the current node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`listRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)`
Retrieves the relatives of the current node.
`void`
`mount(String mountKey)`
Mounts this node.
`void`
`move(String targetNodeId)`
`void`
`move(String targetNodeId, String targetPath)`
Moves the node to a configured target node
`org.gitana.platform.support.ResultMap<BaseNode>`
`queryRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, com.fasterxml.jackson.databind.node.ObjectNode query)`
Queries the relatives of the current node.
`org.gitana.platform.support.ResultMap<BaseNode>`
`queryRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)`
Queries the relatives of the current node.
`Node`
`readTranslation(String edition, Locale locale)`
Reads a translation for the specified edition of the master node in the given locale.
`Node`
`readTranslation(Locale locale)`
Reads a translation for the tip edition of the master node in the given locale.
`String`
`resolvePath()`
Resolves the path for the node relative to the root directory.
`com.fasterxml.jackson.databind.node.ObjectNode`
`resolvePaths()`
Resolves all of the paths for the node.
`void`
`revoke(String principalId, String authorityId)`
Revokes an authority for a principal.
`void`
`revoke(DomainPrincipal principal, String authorityId)`
`void`
`revokeAll(String principalId)`
Revoke all authorities for a principal.
`void`
`revokeAll(DomainPrincipal principal)`
`TraversalResults`
`traverse(com.fasterxml.jackson.databind.node.ObjectNode traverse)`
Runs a traversal around this node using the given configuration.
`void`
`unassociate(Node targetNode, org.gitana.platform.support.QName associationTypeQName)`
Unassociates a target node from this node.
`void`
`unassociate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality)`
Unassociates this node from another node.
`void`
`unmount()`
Unmounts this node.

### Methods inherited from class org.gitana.platform.client.node.BaseNodeImpl

`addFeature, copy, copyAsync, delete, deleteAttachment, deleteAttachment, downloadAttachment, downloadAttachment, equals, getBranch, getBranchId, getChangeset, getChangesetId, getDownloadUri, getDriver, getFactory, getFeature, getFeatureIds, getQName, getRemote, getRepository, getRepositoryId, getResourceUri, getTypeQName, hasFeature, isDeleted, listAttachments, ref, reload, removeFeature, touch, update, uploadAttachment, uploadAttachment, uploadAttachment, uploadAttachments, uploadAttachments`

### Methods inherited from class org.gitana.platform.client.platform.AbstractPlatformDocumentImpl

`copy, copyAsync, exportArchive, exportArchive, exportArchive, getCluster, getPlatform, getPlatformId, importArchive, importArchive, importArchive`

### Methods inherited from class org.gitana.platform.client.document.DocumentImpl

`dateCreated, dateModified, getCreatedBy, getDescription, getId, getModifiedBy, getSystemObject, getTitle, isSaved, mergeProperties, mergePropertyIfExists, reload, reload, setDescription, setId, setSaved, setTitle`

### Methods inherited from class org.gitana.platform.support.GitanaObjectImpl

`_objectGetFloat, _objectGetInt, _objectGetLong, _objectGetObject, _objectGetString, _objectSet, get, getArray, getAsJsonNode, getBigDecimal, getBoolean, getDouble, getInt, getLong, getObject, getObject, getString, has, putAll, putAll, putObject, remove, set, toJSON, toJSONString, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.gitana.platform.client.attachment.Attachable

`deleteAttachment, deleteAttachment, downloadAttachment, downloadAttachment, getDownloadUri, listAttachments, uploadAttachment, uploadAttachment, uploadAttachment, uploadAttachments, uploadAttachments`

### Methods inherited from interface org.gitana.platform.client.node.BaseNode

`addFeature, getBranch, getBranchId, getChangeset, getChangesetId, getFeature, getFeatureIds, getQName, getRepository, getRepositoryId, getTypeQName, hasFeature, isDeleted, removeFeature, touch`

### Methods inherited from interface org.gitana.platform.client.support.Copyable

`copy, copy, copyAsync, copyAsync`

### Methods inherited from interface org.gitana.platform.client.document.Document

`dateCreated, dateModified, getCreatedBy, getId, getModifiedBy, getSystemObject, isSaved, reload, reload, setId, setSaved`

### Methods inherited from interface org.gitana.platform.GitanaObject

`get, getArray, getAsJsonNode, getBigDecimal, getBoolean, getDouble, getInt, getLong, getObject, getObject, getString, has, putAll, putAll, remove, set`

### Methods inherited from interface org.gitana.platform.JSONable

`toJSON, toJSONString`

### Methods inherited from interface org.gitana.platform.client.platform.PlatformDocument

`getPlatform, getPlatformId`

### Methods inherited from interface org.gitana.platform.client.support.Referenceable

`ref`

### Methods inherited from interface org.gitana.platform.client.support.Selfable

`delete, reload, update`

### Methods inherited from interface org.gitana.platform.client.support.TitleDescription

`getDescription, getTitle, setDescription, setTitle`

### Methods inherited from interface org.gitana.platform.client.support.Transferable

`exportArchive, exportArchive, exportArchive, importArchive, importArchive, importArchive`

### Methods inherited from interface org.gitana.platform.client.support.TypedID

`getId`

## Constructor Details

### NodeImpl

public NodeImpl(Branch branch, com.fasterxml.jackson.databind.node.ObjectNode obj, boolean isSaved)
Existing node constructor.

Parameters:
  `branch` -
  `obj` -
  `isSaved` -

## Method Details

### getTypeId

public String getTypeId()

Specified by:
  `getTypeId` in interface `TypedID`

### getACL

public ACL getACL()

Specified by:
  `getACL` in interface `AccessControllable`
Returns:
  access control list

### getACL

public List<String> getACL(String principalId)
Description copied from interface: `AccessControllable`
Retrieve the authorities that a principal has.

Specified by:
  `getACL` in interface `AccessControllable`
Parameters:
  `principalId` -
Returns:
  list

### grant

public void grant(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Grants an authority to a principal.

Specified by:
  `grant` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -

### grant

public void grant(DomainPrincipal principal, String authorityId)

Specified by:
  `grant` in interface `AccessControllable`

### revoke

public void revoke(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Revokes an authority for a principal.

Specified by:
  `revoke` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -

### revoke

public void revoke(DomainPrincipal principal, String authorityId)

Specified by:
  `revoke` in interface `AccessControllable`

### revokeAll

public void revokeAll(String principalId)
Description copied from interface: `AccessControllable`
Revoke all authorities for a principal.

Specified by:
  `revokeAll` in interface `AccessControllable`
Parameters:
  `principalId` -

### revokeAll

public void revokeAll(DomainPrincipal principal)

Specified by:
  `revokeAll` in interface `AccessControllable`

### hasAuthority

public boolean hasAuthority(String principalId, String authorityId)
Description copied from interface: `AccessControllable`
Checks whether the principal has the given authority over this object.

Specified by:
  `hasAuthority` in interface `AccessControllable`
Parameters:
  `principalId` -
  `authorityId` -
Returns:

### hasAuthority

public boolean hasAuthority(DomainPrincipal principal, String authorityId)

Specified by:
  `hasAuthority` in interface `AccessControllable`

### getAuthorityGrants

public Map<String,Map<String,org.gitana.platform.services.authority.AuthorityGrant>> getAuthorityGrants(List<String> principalIds)
Description copied from interface: `AccessControllable`
Acquires a map of authority grants for a set of principals.

Specified by:
  `getAuthorityGrants` in interface `AccessControllable`
Parameters:
  `principalIds` -
Returns:

### hasPermission

public boolean hasPermission(String principalId, String permissionId)
Description copied from interface: `AccessControllable`
Checks whether the principal has the given permission over this object.

Specified by:
  `hasPermission` in interface `AccessControllable`
Parameters:
  `principalId` -
  `permissionId` -
Returns:

### hasPermission

public boolean hasPermission(DomainPrincipal principal, String permissionId)

Specified by:
  `hasPermission` in interface `AccessControllable`

### associations

public org.gitana.platform.support.ResultMap<Association> associations()
Description copied from interface: `Node`
Lists all associations in ANY direction involving this node.

Specified by:
  `associations` in interface `Node`
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Lists all associations in ANY direction involving this node.

Specified by:
  `associations` in interface `Node`
Parameters:
  `pagination` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.services.association.Direction direction)
Description copied from interface: `Node`
Lists all association in the given direction involving this node.

Specified by:
  `associations` in interface `Node`
Parameters:
  `direction` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Lists all association in the given direction involving this node.

Specified by:
  `associations` in interface `Node`
Parameters:
  `direction` -
  `pagination` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.support.QName associationTypeQName)
Description copied from interface: `Node`
Lists all associations of the given type in ANY direction involving this node.

Specified by:
  `associations` in interface `Node`
Parameters:
  `associationTypeQName` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Lists all associations of the given type in ANY direction involving this node.

Specified by:
  `associations` in interface `Node`
Parameters:
  `associationTypeQName` -
  `pagination` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Direction direction)
Description copied from interface: `Node`
Lists all associations of the given type in the specified direction.

Specified by:
  `associations` in interface `Node`
Parameters:
  `associationTypeQName` -
  `direction` -
Returns:
  map

### associations

public org.gitana.platform.support.ResultMap<Association> associations(org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Lists all associations of the given type in the specified direction.

Specified by:
  `associations` in interface `Node`
Parameters:
  `associationTypeQName` -
  `direction` -
  `pagination` -
Returns:
  map

### associate

public Association associate(Node targetNode, org.gitana.platform.support.QName associationTypeQName)
Description copied from interface: `Node`
Associates a target node to this source node. The direction is OUTGOING from this node to the specified node.

Specified by:
  `associate` in interface `Node`
Parameters:
  `targetNode` -
  `associationTypeQName` -
Returns:
  association

### associate

public Association associate(Node targetNode, org.gitana.platform.support.QName associationTypeQName, com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Node`
Associates a target node to this source node. The direction is OUTGOING from this node to the specified node.

Specified by:
  `associate` in interface `Node`
Parameters:
  `targetNode` -
  `associationTypeQName` -
  `object` -
Returns:
  association

### associate

public Association associate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality)
Description copied from interface: `Node`
Associates this node with another.

Specified by:
  `associate` in interface `Node`
Parameters:
  `otherNode` -
  `associationTypeQName` -
  `directionality` -
Returns:
  association

### associate

public Association associate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality, com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Node`
Associates this node with another.

Specified by:
  `associate` in interface `Node`
Parameters:
  `otherNode` -
  `associationTypeQName` -
  `directionality` -
  `object` -
Returns:
  association

### unassociate

public void unassociate(Node targetNode, org.gitana.platform.support.QName associationTypeQName)
Description copied from interface: `Node`
Unassociates a target node from this node.

Specified by:
  `unassociate` in interface `Node`
Parameters:
  `targetNode` -
  `associationTypeQName` -

### unassociate

public void unassociate(Node otherNode, org.gitana.platform.support.QName associationTypeQName, org.gitana.platform.services.association.Directionality directionality)
Description copied from interface: `Node`
Unassociates this node from another node.

Specified by:
  `unassociate` in interface `Node`
Parameters:
  `otherNode` -
  `associationTypeQName` -
  `directionality` -

### traverse

public TraversalResults traverse(com.fasterxml.jackson.databind.node.ObjectNode traverse)
Description copied from interface: `Node`
Runs a traversal around this node using the given configuration.

Specified by:
  `traverse` in interface `Node`
Parameters:
  `traverse` -
Returns:

### mount

public void mount(String mountKey)
Description copied from interface: `Node`
Mounts this node.

Specified by:
  `mount` in interface `Node`
Parameters:
  `mountKey` -

### unmount

public void unmount()
Description copied from interface: `Node`
Unmounts this node.

Specified by:
  `unmount` in interface `Node`

### createTranslation

public Node createTranslation(String edition, Locale locale, com.fasterxml.jackson.databind.node.ObjectNode object)
Description copied from interface: `Node`
Creates a new translation.

Specified by:
  `createTranslation` in interface `Node`
Parameters:
  `edition` - the edition
  `locale` - the locale
  `object` - the json object
Returns:
  node

### getTranslationEditions

public List<String> getTranslationEditions()

Specified by:
  `getTranslationEditions` in interface `Node`
Returns:
  the editions available for this master node

### getTranslationLocales

public List<Locale> getTranslationLocales(String edition)
Description copied from interface: `Node`
Hands back the locales available for a given edition of translations for this master node.

Specified by:
  `getTranslationLocales` in interface `Node`
Parameters:
  `edition` -
Returns:

### readTranslation

public Node readTranslation(Locale locale)
Description copied from interface: `Node`
Reads a translation for the tip edition of the master node in the given locale.

Specified by:
  `readTranslation` in interface `Node`
Parameters:
  `locale` -
Returns:

### readTranslation

public Node readTranslation(String edition, Locale locale)
Description copied from interface: `Node`
Reads a translation for the specified edition of the master node in the given locale.

Specified by:
  `readTranslation` in interface `Node`
Parameters:
  `edition` -
  `locale` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse)
Description copied from interface: `Node`
Queries and searches for nodes in the defined traversal space around this node.

Specified by:
  `findNodes` in interface `Node`
Parameters:
  `query` -
  `searchTerm` -
  `traverse` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Queries and searches for nodes in the defined traversal space around this node.

Specified by:
  `findNodes` in interface `Node`
Parameters:
  `query` -
  `searchTerm` -
  `traverse` -
  `pagination` -
Returns:

### findNodes

public org.gitana.platform.support.ResultMap<BaseNode> findNodes(com.fasterxml.jackson.databind.node.ObjectNode query, String searchTerm, com.fasterxml.jackson.databind.node.ObjectNode traverse, LookupOptions options)
Description copied from interface: `Node`
Queries and searches for nodes in the defined traversal space around this node.

Specified by:
  `findNodes` in interface `Node`
Parameters:
  `query` -
  `searchTerm` -
  `traverse` -
  `options` -
Returns:

### fileFolderTree

public com.fasterxml.jackson.databind.node.ObjectNode fileFolderTree()

Specified by:
  `fileFolderTree` in interface `Node`

### fileFolderTree

public com.fasterxml.jackson.databind.node.ObjectNode fileFolderTree(String basePath)

Specified by:
  `fileFolderTree` in interface `Node`

### fileFolderTree

public com.fasterxml.jackson.databind.node.ObjectNode fileFolderTree(String basePath, String leafPath)

Specified by:
  `fileFolderTree` in interface `Node`

### fileFolderTree

public com.fasterxml.jackson.databind.node.ObjectNode fileFolderTree(String basePath, int depth, List<String> leafPaths, boolean includeProperties, boolean containersOnly, com.fasterxml.jackson.databind.node.ObjectNode query)

Specified by:
  `fileFolderTree` in interface `Node`

### fileFolderTree

public com.fasterxml.jackson.databind.node.ObjectNode fileFolderTree(TreeLookupOptions options)

Specified by:
  `fileFolderTree` in interface `Node`

### move

public void move(String targetNodeId)

Specified by:
  `move` in interface `Node`

### move

public void move(String targetNodeId, String targetPath)
Description copied from interface: `Node`
Moves the node to a configured target node

Specified by:
  `move` in interface `Node`
Parameters:
  `targetNodeId` - id of target folder, default is "root" for top folder
  `targetPath` - optional relative path to apply to targetNodeId for determining move target

### resolvePath

public String resolvePath()
Description copied from interface: `Node`
Resolves the path for the node relative to the root directory.

Specified by:
  `resolvePath` in interface `Node`
Returns:
  the path

### resolvePaths

public com.fasterxml.jackson.databind.node.ObjectNode resolvePaths()
Description copied from interface: `Node`
Resolves all of the paths for the node.

Specified by:
  `resolvePaths` in interface `Node`
Returns:
  paths keyed by root identifier

### listChildren

public org.gitana.platform.support.ResultMap<BaseNode> listChildren()
Description copied from interface: `Node`
Retrieves the children of the current node.

Specified by:
  `listChildren` in interface `Node`
Returns:
  a map of node objects keyed by node id

### listChildren

public org.gitana.platform.support.ResultMap<BaseNode> listChildren(org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Retrieves the children of the current node.

Specified by:
  `listChildren` in interface `Node`
Parameters:
  `pagination` -
Returns:
  a map of node objects keyed by node id

### listRelatives

public org.gitana.platform.support.ResultMap<BaseNode> listRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction)
Description copied from interface: `Node`
Retrieves the relatives of the current node.

Specified by:
  `listRelatives` in interface `Node`
Parameters:
  `type` -
  `direction` -
Returns:
  a map of node objects keyed by node id

### listRelatives

public org.gitana.platform.support.ResultMap<BaseNode> listRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Retrieves the relatives of the current node.

Specified by:
  `listRelatives` in interface `Node`
Parameters:
  `type` -
  `direction` -
  `pagination` -
Returns:
  a map of node objects keyed by node id

### queryRelatives

public org.gitana.platform.support.ResultMap<BaseNode> queryRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, com.fasterxml.jackson.databind.node.ObjectNode query)
Description copied from interface: `Node`
Queries the relatives of the current node.

Specified by:
  `queryRelatives` in interface `Node`
Parameters:
  `type` -
  `direction` -
  `query` -
Returns:
  map of nodes

### queryRelatives

public org.gitana.platform.support.ResultMap<BaseNode> queryRelatives(org.gitana.platform.support.QName type, org.gitana.platform.services.association.Direction direction, com.fasterxml.jackson.databind.node.ObjectNode query, org.gitana.platform.support.Pagination pagination)
Description copied from interface: `Node`
Queries the relatives of the current node.

Specified by:
  `queryRelatives` in interface `Node`
Parameters:
  `type` -
  `direction` -
  `query` -
  `pagination` -
Returns:
  map of nodes